﻿using System;
using System.IO;
using System.Linq;
using System.Windows.Forms;
using System.Xml.Linq;

namespace CSScriptIntellisense
{
    public partial class ConfigForm : Form
    {
        Config data;

        public ConfigForm()
        {
            InitializeComponent();
        }

        public ConfigForm(Config data)
        {
            this.data = data;

            InitializeComponent();

            useArrow.Checked = data.UseArrowToAccept;
            useMethodBrackets.Checked = data.UseMethodBrackets;
            intercept.Checked = data.InterceptCtrlSpace;

            this.FormClosed += (s, e) =>
                {
                    data.UseArrowToAccept = useArrow.Checked;
                    data.InterceptCtrlSpace = intercept.Checked;
                    data.UseMethodBrackets = useMethodBrackets.Checked;
                };
        }

        private void ConfigForm_Load(object sender, EventArgs e)
        {
            string tooltip =
                         "Checking this option remap C# Intellisense to Ctrl+Space.\n" +
                         "This will also force C# Intellisense to invoke\n" +
                         "native Notepad++ Auto-Completion for non .cs files."+
                         "\n"+
                         "Note that it will also remap \"Add missing 'using'\" to Ctrl+.\n"+
                         "to make it more consistent with the default Visual Studio\n" +
                         "shortcut mapping";
            this.toolTip1.SetToolTip(this.intercept, tooltip);
        }

        //Publishing with Plugin manager:
        ///http://www.brotherstone.co.uk/npp/pm/

        /*
         * C:\Users\<user>\AppData\Roaming\Notepad++\shortcuts.xml
         *  <NotepadPlus>
         *      <InternalCommands>
         *          <Shortcut id="50000" Ctrl="yes" Alt="yes" Shift="yes" Key="32" />
         *      </InternalCommands>
         */
    }
}